#include <stdio.h>

int main(int argc, char *argv[]) {
    char *cmdname = argv[0];	/* Kommando-Name */
    int opt_x = 0;		/* Option -x gesetzt? */
    int opt_n = 0;		/* Option -n gesetzt? */
    int opterr = 0;		/* Fehler bei den Optionen? */
    char *s;

	/* Optionen verarbeiten */
    while (--argc > 0 && (*++argv)[0] == '-') {
	/* nach "--" kommen keine Optionen mehr (per Definition) */
	if ((*argv)[1] == '-' && (*argv)[2] == '\0') {
	    argc--; argv++; break;
	}
	/* steht nur "-", dann fehlt etwas ;-) */
	if ((*argv)[1] == '\0') {
	    fprintf(stderr, "Empty option\n");
	    opterr = 1;
	}
	for (s = *argv + 1; *s != '\0'; s++)
	    switch (*s) {	/* jede einzelne Option abarbeiten ... */
		case 'x' : opt_x = 1; break;
		case 'n' : opt_n = 1; break;
		default:	/* unbekannte Option! */
		    fprintf(stderr, "Illegal option '%c'\n", *s);
		    opterr = 1;
		    break;
	    }
    }

    /* argv und argc wurden veraendert! */

    if (argc > 1)
	fprintf(stderr, "Too many arguments\n");
    else if (argc == 0)
	fprintf(stderr, "Too few arguments\n");

    if (argc != 1 || opterr) {
	fprintf(stderr, "Usage: %s [-nx] [-a name] pattern\n", cmdname);
	return 1;
    }

    /* nur zum Test ... ein bisschen ausgeben */
    if (opt_n)
	puts("Option -n gesetzt");    
    if (opt_x)
	puts("Option -x gesetzt");    
    printf("Argument: %s\n", *argv);

    /* ... hier geht's weiter ... */

    return 0;
}
