#include <sys/types.h>	/* notwendige ... */
#include <sys/stat.h>	/* ... Includes */
#include <stdio.h>
#include <stdlib.h>

int main(int argc, char **argv) {
    struct stat statbuf;

    if (argc != 2) {
	fprintf(stderr, "Usage: %s <file>\n", argv[0]);
	exit(1);	/* Programm mit Exit-Status 1 terminieren */
    }

    /* oder auch stat() -- je nach Absicht */
    if (lstat(argv[1], &statbuf) < 0)
	perror("stat()"), exit(2);

    /* Wir bestimmen, welche Rechte die Gruppe hat:
     * Mit der Oktalmaske 040 erhaelt man das Leserecht fuer die Gruppe,
     * mit der Oktalmaske 020 das Schreibrecht fuer die Gruppe und
     * mit der Oktalmaske 010 das Ausfuehrungsrecht fuer die Gruppe. */
    printf("Rechte der Gruppe: %c%c%c\n",
	statbuf.st_mode & 040 ? 'r' : '-',
	statbuf.st_mode & 020 ? 'w' : '-',
	statbuf.st_mode & 010 ? 'x' : '-');

    /* Ueberpruefung, ob es sich um ein Verzeichnis handelt, ist
     * auf zwei Arten moeglich:
     */

    printf("Verzeichnis? %s\n", S_ISDIR(statbuf.st_mode) ? "ja" : "nein");

    printf("Verzeichnis? %s\n", (statbuf.st_mode & S_IFMT) == S_IFDIR ? "ja" : "nein");

    exit(0);
}
